#!/usr/bin/ruby

$LOAD_PATH << File.expand_path(File.dirname(__FILE__))
require 'amarok_melon'

lastURL = nil

loop do
  status = `dcop amarok player status`.chomp.to_i
  if status == 2 then
    encodedURL = `dcop amarok player encodedURL`
    if encodedURL != lastURL && !AmarokMelon.hasCover? then
      lastURL = encodedURL
      path = `dcop amarok player path`.slice(/.*\//)
      return if path == nil
      path += `dcop amarok player album`.chomp + ".jpg"
      AmarokMelon.translate!(path)
      artist = `dcop amarok player artist`.chomp.strip
      album = `dcop amarok player album`.chomp.strip
      query = artist + ' ' + album
      coverUrl = AmarokMelon.getCoverUrl(query)
      if coverUrl == nil then
        sqAlbum = CGI.unescape(album).sub(/([0-9]*\.)?[0-9]*집/, "").delete('-').strip
        query = artist + ' ' + sqAlbum
        coverUrl = AmarokMelon.getCoverUrl(query) if sqAlbum != album && sqAlbum != ""
        if coverUrl == nil then
          sqAlbum = CGI.unescape(album).gsub(/([0-9]*\.)?[0-9]*(집)?/, "").delete('-').gsub(/\([^\)]*\)/, "").strip
          query = artist + ' ' + sqAlbum
          coverUrl = AmarokMelon.getCoverUrl(query) if sqAlbum != album && sqAlbum != ""
        end
      end
      if coverUrl != nil then
        `wget -O '#{path}' '#{coverUrl}'`
        `dcop amarok collection scanCollectionChanges`
      end
    end
  end
  sleep 10
end
