# Core covers_melon
# This file fetches cover from melon.
#
# ChangeLog:
# 26 Mar 2007: Added support for euc-kr.
#
require 'my_web'
require 'cgi'
require 'iconv'

module AmarokMelon
  def AmarokMelon.getQueryString(query)
    CGI.escape(MyWeb.encodeToEucKr(CGI.unescape(query).delete('.')))
  rescue Iconv::IllegalSequence
    return CGI.escape(CGI.unescape(query))
  end

  def AmarokMelon.getCoverUrl(query)
    queryStr = getQueryString(query)
    url = "http://www.melon.com/utility/searchm/search.jsp?q1=&c=kwdauto&w=web_album&q=#{queryStr}"
    body = MyWeb.fetchFromHttp(url)
    matched = body.match(/writeAlbumImgList\(\'([^']*)\'/)
    matched != nil ? matched.captures : nil
  end

  def AmarokMelon.hasCover?
    !`dcop amarok player coverImage`.include?("100@nocover.png")
  end

  def AmarokMelon.translate!(str)
    str.tr!('`', '_')
    str.tr!("\'", '_')
    str.tr!("\"", '_')
  end
end
